pcl::registration::CorrespondenceRejectorFeatures::FeatureContainer< FeatureT > Class Template Reference

An inner class containing pointers to the source and target feature clouds and the parameters needed to perform the correspondence search. More...

`#include <pcl/registration/correspondence_rejection_features.h>`

Inheritance diagram for pcl::registration::CorrespondenceRejectorFeatures::FeatureContainer< FeatureT >:

## Public Types

using | FeatureCloudConstPtr = typename pcl::PointCloud< FeatureT >::ConstPtr
using | SearchMethod = std::function< int(const pcl::PointCloud< FeatureT > &, int, std::vector< int > &, std::vector< float > &)>
using | PointRepresentationConstPtr = typename pcl::PointRepresentation< FeatureT >::ConstPtr
Public Types inherited from pcl::registration::CorrespondenceRejectorFeatures::FeatureContainerInterface
using | Ptr = shared_ptr< FeatureContainerInterface >

## Public Member Functions

| FeatureContainer ()
| ~FeatureContainer ()
| Empty destructor. More...
void | setSourceFeature (const FeatureCloudConstPtr &source_features)
FeatureCloudConstPtr | getSourceFeature ()
void | setTargetFeature (const FeatureCloudConstPtr &target_features)
FeatureCloudConstPtr | getTargetFeature ()
void | setDistanceThreshold (double thresh)
bool | isValid () override
void | setFeatureRepresentation (const PointRepresentationConstPtr &fr)
| Provide a boost shared pointer to a PointRepresentation to be used when comparing features. More...
double | getCorrespondenceScore (int index) override
| Obtain a score between a pair of correspondences. More...
bool | isCorrespondenceValid (int index) override
| Check whether the correspondence pair at the given index is valid by computing the score and testing it against the user given threshold. More...
Public Member Functions inherited from pcl::registration::CorrespondenceRejectorFeatures::FeatureContainerInterface
virtual | ~FeatureContainerInterface ()=default
| Empty destructor. More...

## Detailed Description

### template<typename FeatureT>
class pcl::registration::CorrespondenceRejectorFeatures::FeatureContainer< FeatureT >

An inner class containing pointers to the source and target feature clouds and the parameters needed to perform the correspondence search.

This class extends FeatureContainerInterface, which contains abstract methods for any methods that do not depend on the FeatureT — these methods can thus be called from a pointer to FeatureContainerInterface without casting to the derived class.

Definition at line 180 of file correspondence_rejection_features.h.

## Member Typedef Documentation

## FeatureCloudConstPtr

template<typename FeatureT >

using pcl::registration::CorrespondenceRejectorFeatures::FeatureContainer< FeatureT >::FeatureCloudConstPtr = typename pcl::PointCloud<FeatureT>::ConstPtr

Definition at line 183 of file correspondence_rejection_features.h.

## PointRepresentationConstPtr

template<typename FeatureT >

using pcl::registration::CorrespondenceRejectorFeatures::FeatureContainer< FeatureT >::PointRepresentationConstPtr = typename pcl::PointRepresentation<FeatureT>::ConstPtr

Definition at line 186 of file correspondence_rejection_features.h.

## SearchMethod

template<typename FeatureT >

using pcl::registration::CorrespondenceRejectorFeatures::FeatureContainer< FeatureT >::SearchMethod = std::function<int (const pcl::PointCloud<FeatureT> &, int, std::vector<int> &, std::vector<float> &)>

Definition at line 184 of file correspondence_rejection_features.h.

## Constructor & Destructor Documentation

## FeatureContainer()

template<typename FeatureT >

pcl::registration::CorrespondenceRejectorFeatures::FeatureContainer< FeatureT >::FeatureContainer | ( |  | ) |

inline

Definition at line 188 of file correspondence_rejection_features.h.

## ~FeatureContainer()

template<typename FeatureT >

pcl::registration::CorrespondenceRejectorFeatures::FeatureContainer< FeatureT >::~FeatureContainer | ( |  | ) |

inline

Empty destructor.

Definition at line 193 of file correspondence_rejection_features.h.

## Member Function Documentation

## getCorrespondenceScore()

template<typename FeatureT >

double pcl::registration::CorrespondenceRejectorFeatures::FeatureContainer< FeatureT >::getCorrespondenceScore | ( | int | index | ) |

inline override virtual

Obtain a score between a pair of correspondences.

Parameters

  [in] | index | the index to check in the list of correspondences

Returns
  score the resultant computed score

Implements pcl::registration::CorrespondenceRejectorFeatures::FeatureContainerInterface.

Definition at line 248 of file correspondence_rejection_features.h.

## getSourceFeature()

template<typename FeatureT >

FeatureCloudConstPtr pcl::registration::CorrespondenceRejectorFeatures::FeatureContainer< FeatureT >::getSourceFeature | ( |  | ) |

inline

Definition at line 202 of file correspondence_rejection_features.h.

Referenced by pcl::registration::CorrespondenceRejectorFeatures::getSourceFeature().

## getTargetFeature()

template<typename FeatureT >

FeatureCloudConstPtr pcl::registration::CorrespondenceRejectorFeatures::FeatureContainer< FeatureT >::getTargetFeature | ( |  | ) |

inline

Definition at line 214 of file correspondence_rejection_features.h.

Referenced by pcl::registration::CorrespondenceRejectorFeatures::getTargetFeature().

## isCorrespondenceValid()

template<typename FeatureT >

bool pcl::registration::CorrespondenceRejectorFeatures::FeatureContainer< FeatureT >::isCorrespondenceValid | ( | int | index | ) |

inline override virtual

Check whether the correspondence pair at the given index is valid by computing the score and testing it against the user given threshold.

Parameters

  [in] | index | the index to check in the list of correspondences

Returns
  true if the correspondence is good, false otherwise

Implements pcl::registration::CorrespondenceRejectorFeatures::FeatureContainerInterface.

Definition at line 281 of file correspondence_rejection_features.h.

## isValid()

template<typename FeatureT >

bool pcl::registration::CorrespondenceRejectorFeatures::FeatureContainer< FeatureT >::isValid | ( |  | ) |

inline override virtual

Implements pcl::registration::CorrespondenceRejectorFeatures::FeatureContainerInterface.

Definition at line 226 of file correspondence_rejection_features.h.

## setDistanceThreshold()

template<typename FeatureT >

void pcl::registration::CorrespondenceRejectorFeatures::FeatureContainer< FeatureT >::setDistanceThreshold | ( | double | thresh | ) |

inline

Definition at line 220 of file correspondence_rejection_features.h.

## setFeatureRepresentation()

template<typename FeatureT >

void pcl::registration::CorrespondenceRejectorFeatures::FeatureContainer< FeatureT >::setFeatureRepresentation | ( | const PointRepresentationConstPtr & | fr | ) |

inline

Provide a boost shared pointer to a PointRepresentation to be used when comparing features.

Parameters

  [in] | fr | the point feature representation to be used

Definition at line 238 of file correspondence_rejection_features.h.

## setSourceFeature()

template<typename FeatureT >

void pcl::registration::CorrespondenceRejectorFeatures::FeatureContainer< FeatureT >::setSourceFeature | ( | const FeatureCloudConstPtr & | source_features | ) |

inline

Definition at line 196 of file correspondence_rejection_features.h.

## setTargetFeature()

template<typename FeatureT >

void pcl::registration::CorrespondenceRejectorFeatures::FeatureContainer< FeatureT >::setTargetFeature | ( | const FeatureCloudConstPtr & | target_features | ) |

inline

Definition at line 208 of file correspondence_rejection_features.h.

The documentation for this class was generated from the following file:

- pcl/registration/correspondence_rejection_features.h